StartupEvents.registry('palladium:abilities', (event) => {
    event.create('alienevo:obtain_core_colors')
        .icon(palladium.createItemIcon('palladium:vibranium_circuit'))
        .firstTick((entity, entry, holder) => {
            let colorNames = [
                'white',       // 0
                'lightgray',   // 1
                'gray',        // 2
                'black',       // 3
                'brown',       // 4
                'red',         // 5
                'orange',      // 6
                'yellow',      // 7
                'green',       // 8
                'lime',        // 9 (lime color)
                'cyan',        // 10
                'lightblue',   // 11
                'blue',        // 12
                'purple',      // 13
                'magenta',     // 14
                'pink'         // 15
            ];
            
            let colorIndex = getRandomInt(0, 15);
            let colorName = colorNames[colorIndex];
            
            palladium.setProperty(entity, 'AlienEvo.Color', colorName);
            entity.persistentData.putString('color_value', colorName);
        })
        .tick((entity, entry, holder, enabled) => {
            if (enabled) {
                let coreItems = {
                    'default': 'alienevo:prototype_core',
                    'white': 'alienevo:prototype_core_white',
                    'lightgray': 'alienevo:prototype_core_light_gray',
                    'gray': 'alienevo:prototype_core_gray',
                    'black': 'alienevo:prototype_core_black',
                    'brown': 'alienevo:prototype_core_brown',
                    'red': 'alienevo:prototype_core_red',
                    'orange': 'alienevo:prototype_core_orange',
                    'yellow': 'alienevo:prototype_core_yellow',
                    'green': 'alienevo:prototype_core_green',
                    'lime': 'alienevo:prototype_core',
                    'cyan': 'alienevo:prototype_core_cyan',
                    'lightblue': 'alienevo:prototype_core_light_blue',
                    'blue': 'alienevo:prototype_core_blue',
                    'purple': 'alienevo:prototype_core_purple',
                    'magenta': 'alienevo:prototype_core_magenta',
                    'pink': 'alienevo:prototype_core_pink'
                };
                
                try {
                    let entityX = entity.x;
                    let entityY = entity.y;
                    let entityZ = entity.z;
                    
                    let nearbyPlayer = null;
                    let closestDistance = 2.25;
                    
                    let allPlayers = entity.level.players;
                    for (let i = 0; i < allPlayers.length; i++) {
                        let player = allPlayers[i];
                        
                        let dx = player.x - entityX;
                        let dy = player.y - entityY;
                        let dz = player.z - entityZ;
                        let distSq = dx * dx + dy * dy + dz * dz;
                        
                        if (distSq < closestDistance) {
                            nearbyPlayer = player;
                            closestDistance = distSq;
                        }
                    }
                    
                    if (nearbyPlayer) {
                        let colorName = entity.persistentData.getString('color_value');
                        if (!colorName || colorName === '') {
                            colorName = palladium.getProperty(entity, 'AlienEvo.Color') || 'default';
                        }
                        
                        let itemId = coreItems[colorName] || 'alienevo:prototype_core';
                        
                        let coreItem = Item.of(itemId);
                        
                        let nbtData = {};
                        
                        nbtData.storedColor = colorName;
                        
                        coreItem.setNbt(nbtData);
                        
                        nearbyPlayer.give(coreItem);
                        
                        entity.kill();
                        entity.remove();
                        
                        if (entity.health) {
                            entity.health = 0;
                        }
                        
                        entity.discard();
                    }
                } catch (e) {
                }
            }
        });
});

function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1)) + min;
}