StartupEvents.registry('palladium:abilities', (event) => {
  event.create('alienevo:screenshake_loop')
    .icon(palladium.createItemIcon('minecraft:piston'))
    .addProperty("vertical_intensity", "float", 0.3, "Vertical Shake Intensity (degrees)")
    .addProperty("horizontal_intensity", "float", 1.0, "Horizontal Shake Intensity (degrees)")
    .addProperty("frequency", "float", 1.0, "Speed multiplier (1.0 = normal, 2.0 = faster)")
    .tick((entity, entry, holder, enabled) => {
      if (enabled && entity.isPlayer()) {
        let vertIntensity = entry.getPropertyByName("vertical_intensity");
        let horizIntensity = entry.getPropertyByName("horizontal_intensity");
        let frequency = entry.getPropertyByName("frequency");

        switch (Math.floor((entity.level.time * frequency) % 4)) {
          case 0:
            entity.runCommandSilent(
              `execute as @s at @s run tp @s ~ ~ ~ ~${horizIntensity} ~${vertIntensity}`
            );
            break;
          case 1:
            entity.runCommandSilent(
              `execute as @s at @s run tp @s ~ ~ ~ ~${-horizIntensity} ~${-vertIntensity}`
            );
            break;
          case 2:
            entity.runCommandSilent(
              `execute as @s at @s run tp @s ~ ~ ~ ~${-horizIntensity} ~${vertIntensity}`
            );
            break;
          case 3:
            entity.runCommandSilent(
              `execute as @s at @s run tp @s ~ ~ ~ ~${horizIntensity} ~${-vertIntensity}`
            );
            break;
        }
      }
    });
});