PalladiumEvents.registerAnimations((event) => {
    event.register('ball/form', 200, (builder) => {
        let ball_form = animationUtil.getAnimationTimerAbilityValue(
            builder.getPlayer(), 'alienevo_aliens:arburian_pelarota', 'ball_timer', builder.getPartialTicks());
        builder.get('right_arm')
            .setXRotDegrees(0).setYRotDegrees(0).setZRotDegrees(0)
            .animate('InOutCubic', ball_form);
        builder.get('left_arm')
            .setXRotDegrees(0).setYRotDegrees(0).setZRotDegrees(0)
            .animate('InOutCubic', ball_form);
        if (ball_form > 0.0 && builder.isFirstPerson()) {
            builder.get('right_arm')
                .setY(10).setX(15).setZ(15)
                .setXRotDegrees(0).setZRotDegrees(-15).setYRotDegrees(-15)
                .translateZ(20).translateX(30).translateY(-2)
                .animate('InOutCubic', ball_form);
        builder.get('left_arm')
            .setY(10).setX(-15).setZ(15)
            .setXRotDegrees(0).setZRotDegrees(15).setYRotDegrees(15)
            .translateZ(20).translateX(-30).translateY(-2)
            .animate('InOutCubic', ball_form);
    }
});
});
//PalladiumEvents.registerAnimations((event) => {
//    event.register('alienevo/roll', 15, (builder) => {
//        let roll = animationUtil.getAnimationTimerAbilityValue(
//            builder.getPlayer(),
//            'alienevo_aliens:arburian_pelarota',
//            'ball_timer', 
//            builder.getPartialTicks()
//        );
        
//        if (roll > 0.0 && !builder.isFirstPerson()) {
//            builder.get('chest')
//                .setXRotDegrees(roll * 360)
//                .animate('easeInOutQuart', roll);
//        }
//    });
//});

//PalladiumEvents.registerAnimations((event) => {
//    let rotationAccumulator = 0;
//    let rotationSpeed = 0;
//    let isSlowingDown = false;
//    
//    event.register('alienevo/roll', 15, (builder) => {
//        let animation = animationUtil.getAnimationTimerAbilityValue(
//            builder.getPlayer(),
//            'alienevo_aliens:arburian_pelarota',
//            'ball_timer',
//            builder.getPartialTicks()
//        );
//        if (animation > 0.0 && !builder.isFirstPerson()) {
//            let speed = event.player.motion;
//            
//            if (speed > 0.01) {
//                isSlowingDown = false;
//                rotationSpeed = speed * 2;
//            } else if (!isSlowingDown) {
//                isSlowingDown = true;
//                rotationSpeed = 2;
//            }
//            
//            if (isSlowingDown) {
//                rotationSpeed *= 0.97;
//            }
//            rotationAccumulator += rotationSpeed;
//            if (rotationAccumulator >= 360) {
//                rotationAccumulator = 0;
//            }
//            builder.get('chest')
//                .setXRotDegrees(rotationAccumulator)
//                .animate('easeInOutQuart', animation);
//        } else {
//            rotationSpeed = 0;
//            rotationAccumulator = 0;
//            isSlowingDown = false;
//        }
//    });
// });
PalladiumEvents.registerAnimations((event) => {
    event.register('alienevo/aburian_loop', 15, (builder) => {
		
		if (abilityUtil.isEnabled(builder.getPlayer(), "alienevo_aliens:arburian_pelarota", "arburian_loop")) {
		if (!builder.isFirstPerson()) {
            builder.get('left_arm')
            .rotateX(builder.getModel().leftArm.xRot * -0.65 + builder.getModel().head.xRot*0.33)
            .setX(5-builder.getModel().head.yRot*0.5)
            .setZ(-builder.getModel().head.yRot*2.5-builder.getModel().head.xRot*4)
	        builder.get('right_arm')
            .rotateX(builder.getModel().rightArm.xRot * -0.65 + builder.getModel().head.xRot*0.33)
            .setX(-5-builder.getModel().head.yRot*0.5)
            .setZ(builder.getModel().head.yRot*2.5-builder.getModel().head.xRot*4)
            builder.get('right_leg').rotateX(builder.getModel().rightLeg.xRot * -0.75)
	        builder.get('left_leg').rotateX(builder.getModel().leftLeg.xRot * -0.75)
            builder.get('chest')
            .rotateX(builder.getModel().head.xRot*0.33)
            .setZ(-builder.getModel().head.xRot*5)
            .rotateY(builder.getModel().head.yRot*0.33)
        }
    }

    });
});


NetworkEvents.dataReceived('roll_state', event => {
    // Handle any network data here
});
ClientEvents.tick(event => {
    if (abilityUtil.hasPower(event.player, "alienevo_aliens:arburian_pelarota")) {
        if (abilityUtil.isEnabled(event.player, "alienevo_aliens:arburian_pelarota", "ball_roll")) {
            let mode = Client.options.getCameraType();
            if (mode !== 'third_person_back' && mode !== 'third_person_front') {
                event.player.persistentData.camera_reset = 1;
                Client.options.setCameraType('third_person_back');
            }
        }

        let end = event.player.persistentData.camera_reset;
        if (!abilityUtil.isEnabled(event.player, "alienevo_aliens:arburian_pelarota", "ball_roll") && end === 1) {
            event.player.persistentData.camera_reset = 0;
            Client.options.setCameraType('first_person');
        }
    }
});